function [Y_PCLHR,Z_PCLHR,Ylocal_PCLHR,Zlocal_PCLHR,AlfaX_PCLHR,AlfaY_PCLHR,TempDef_PCLHR,...
    speed_PCLHR,speed_local_PCLHR,acceleration_PCLHR,acceleration_local_PCLHR,ARRAYdate_PCLHR,...
    ErrPreConvLinkHR] = elab2D_PCLHR(IDcentralina,DTcatena,rPCLHR,AngDef_PCLHR,...
    TempDef_PCLHR,SpePCLHR,DatiElabPreConvLinkHR,Ndevst_HR,Wdevst_HR,ARRAYdate_PCLHR,...
    NuovoZeroPCLHR,NdatiMedia,Ndatidespike,ErrPreConvLinkHR,margine,elab_option,Tmax,Tmin,...
    datainiPCLHR,FileName)

%% Inizializzazione
fileID = fopen(FileName,'a');
fmt = '%s \r';
text = 'elab2D_PCLHR function started';
fprintf(fileID,fmt,text);

if NuovoZeroPCLHR == 1
   if NdatiMedia > Ndatidespike
        Ndati = NdatiMedia;
    else
        Ndati = Ndatidespike;
    end
    ini = round(Ndati/2)+1;
    if rem(Ndati,2) == 0
        ini = ini+1;
    end
    clear NDati
    ini = ini + margine;
    if ini < 6
        ini = 6;
    end
    if Ndevst_HR ~= 0 % Allora prendo tutti i dati e solo in seguito considero i nuovi, a valle della funzione filtro
        ini = 1;
    end
    AngDef_PCLHR = AngDef_PCLHR(ini:end,:);
    TempDef_PCLHR = TempDef_PCLHR(ini:end,:);
    DatiElabPreConvLinkHR = DatiElabPreConvLinkHR(ini:end,:);
    ARRAYdate_PCLHR = ARRAYdate_PCLHR(ini:end,1); 
    ErrPreConvLinkHR = ErrPreConvLinkHR(ini:end,:);
end

%% Definisco i dati
Nnodi = rPCLHR;
% Spacchetto
[r,~] = size(AngDef_PCLHR); % Numero di dati
[Ndati,~] = size(ARRAYdate_PCLHR);
ax = zeros(r,Nnodi);
ay = zeros(r,Nnodi);
for i=1:Nnodi
    ax(:,i) = AngDef_PCLHR(:,(i-1)*2+1); % ax
    ay(:,i) = AngDef_PCLHR(:,(i-1)*2+2); % ay
end
ax = ax'; % riga nodi, colonna date
ay = ay'; % riga nodi, colonna date

%% Costruzione delle matrici

% Dati locali
asseY_PCLHR = zeros(Nnodi,Ndati); % Raccoglie i dati planari locali nella direzione di sviluppo della catena
asseZ_PCLHR = zeros(Nnodi,Ndati); % Raccoglie i dati planari locali nella direzione di sviluppo della catena, basso->alto

% Dati cumulati
Y_PCLHR = zeros(Nnodi,Ndati); % Raccoglie i dati cumulati nella direzione di sviluppo della catena
Z_PCLHR = zeros(Nnodi,Ndati); % Raccoglie i dati cumulati nella direzione di sviluppo della catena, basso->alto

% Angoli
AlfaX_PCLHR = zeros(Nnodi,Ndati); 
AlfaY_PCLHR = zeros(Nnodi,Ndati); % 

% parametri per il calcolo
SpePCLHR = SpePCLHR(2:end,1); % valori segmenti di pertinenza

% Inizio del ciclo di elaborazione
text = 'Elaboration of PreConv Link HR started';
fprintf(fileID,fmt,text);
ax = 0.01745329251994329576923690768489.*ax;
ay = 0.01745329251994329576923690768489.*ay;
for jj = 1:Ndati
    if jj == 1 % al primo dato raccolto riporto i punti di calcolo sui punti noti
       % INPUT SITO SPECIFICO DA DARE !!!
       fclose(fileID);
       if NuovoZeroPCLHR == 0
          [cYo,cZo,asseY_Rif_PCLHR,asseZ_Rif_PCLHR] = punti_noti_PCLHR(...
              IDcentralina,DTcatena,FileName);
       elseif NuovoZeroPCLHR == 1 % calcolo a partire da dati già elaborati a cui mi riferisco
              [cYo,cZo,asseY_Rif_PCLHR,asseZ_Rif_PCLHR] = punti_noti_exe_PCLHR(...
                  asseY_PCLHR,DatiElabPreConvLinkHR,FileName);
       end  
       for ii = 1:Nnodi
           [Y_PCLHR,Z_PCLHR,asseY_PCLHR,asseZ_PCLHR,AlfaX_PCLHR,AlfaY_PCLHR] = ...
               CalcoloBiax_PCLHR(SpePCLHR,ii,jj,ax,ay,asseY_PCLHR,asseZ_PCLHR,asseY_Rif_PCLHR,...
               asseZ_Rif_PCLHR,Y_PCLHR,Z_PCLHR,AlfaX_PCLHR,AlfaY_PCLHR,elab_option,rPCLHR);
       end
       [shiftY_PCLHR,shiftZ_PCLHR] = pos_ini_PCLHR(cYo,cZo,Y_PCLHR,Z_PCLHR); 
%      riporto Y e Z sui punti noti
       Y_PCLHR(:,jj) = Y_PCLHR(:,jj) - shiftY_PCLHR(:,1);
       Z_PCLHR(:,jj) = Z_PCLHR(:,jj) - shiftZ_PCLHR(:,1); 
    else
       for ii = 1:Nnodi
           [Y_PCLHR,Z_PCLHR,asseY_PCLHR,asseZ_PCLHR,AlfaX_PCLHR,AlfaY_PCLHR] = ...
               CalcoloBiax_PCLHR(SpePCLHR,ii,jj,ax,ay,asseY_PCLHR,asseZ_PCLHR,asseY_Rif_PCLHR,...
               asseZ_Rif_PCLHR,Y_PCLHR,Z_PCLHR,AlfaX_PCLHR,AlfaY_PCLHR,elab_option,rPCLHR);
       end
       %      correggo X e Z con gli offset
       Y_PCLHR(:,jj) = Y_PCLHR(:,jj) - shiftY_PCLHR(:,1);
       Z_PCLHR(:,jj) = Z_PCLHR(:,jj) - shiftZ_PCLHR(:,1); 
   end 
end 

Yrif = Y_PCLHR; % mi serve dopo
Zrif = Z_PCLHR; % mi serve dopo
dY_PCLHR = diff(asseY_PCLHR,1,2);
dZ_PCLHR = diff(asseZ_PCLHR,1,2);

%% Controllo della Temperatura
clear r
clear rr
clear c
clear cc
[r,c] = size(Z_PCLHR);

fileID = fopen(FileName,'a');
fmt = '%s \r';
fprintf(fileID,fmt,text);
clear i
clear j
cont = 1; % contatore
TempDef_PCLHR = TempDef_PCLHR';
text = 'There are not correction of PreConv Link HR based on temperature filter';

FileTemperature = ['' IDcentralina '-' DTcatena '-TLHRH-Therm.csv'];
if isfile(FileTemperature) == 1
    DatiRaw = csvread(FileTemperature);
    [rDR,cDR] = size(DatiRaw);
    DatiRaw(:,1) = DatiRaw(:,1) + 730000;
else
    rDR = 1;
    cDR = 1;
end

for j = 1:c % Data
    for i = 1:r % Nodo
        % NON considero i dati al di sopra di Tmax o al di sotto di Tmin
        if TempDef_PCLHR(i,j) > Tmax || TempDef_PCLHR(i,j) < Tmin
            cont = cont+1;
            if j == 1
                if isfile(FileTemperature) == 1
                    RawDate = find(DatiRaw(:,1)<=datenum(datainiPCLHR));
                    if isempty(RawDate) == 1
                        cc = 2;
                        while cc <= Ndate
                            if TempDef_PCLHR(i,cc) > Tmax || TempDef_PCLHR(i,cc) < Tmin
                                cc = cc+1;
                            else
                                break
                            end
                        end
                        TempDef_PCLHR(i,j) = TempDef_PCLHR(i,cc);
                    else
                        if isnan(DatiRaw(RawDate(end),i+1)) == 0
                            TempDef_PCLHR(i,j) = DatiRaw(RawDate(end),i+1);
                            dY_PCLHR(i,j-1) = 0;
                            dZ_PCLHR(i,j-1) = 0;
                            ErrPreConvLinkHR(j,i) = 0.5;
                            wardat = 'Temperature data of PreConv Link HR nodes corrected using Raw Data of reference Csv file.';
                            fprintf(fileID,fmt,wardat);
                        else
                            cc = 2;
                            while cc <= c
                                if TempDef_PCLHR(i,cc) > Tmax || TempDef_PCLHR(i,cc) < Tmin
                                    cc = cc+1;
                                else
                                    break
                                end
                            end
                            TempDef_PCLHR(i,j) = TempDef_PCLHR(i,cc);
                        end
                    end
                else
                    cc = 2;
                    while cc <= c
                        if TempDef_PCLHR(i,cc) > Tmax || TempDef_PCLHR(i,cc) < Tmin
                            cc = cc+1;
                        else
                            break
                        end
                    end
                    TempDef_PCLHR(i,j) = TempDef_PCLHR(i,cc);
                end
            else       
                dY_PCLHR(i,j-1) = 0;
                dZ_PCLHR(i,j-1) = 0;
                TempDef_PCLHR(i,j) = TempDef_PCLHR(i,j-1);
                ErrPreConvLinkHR(j,i) = 0.5;
            end
        end
        text = ['' num2str(cont) ' correction executed for Tilt Link HR H - Temperature filter!'];
    end
end

if  rDR~=1 && cDR~=1 && isempty(DatiRaw) == 0
    RawDate1 = find(DatiRaw(:,1)<=ARRAYdate_PCLHR(1));
    if isempty(RawDate1) == 1
        RawDate2 = 1;
    elseif RawDate1(end) == rDR
        RawDate2 = find(ARRAYdate_PCLHR(:,1)>DatiRaw(end,1));
    else
        RawDate2 = find(ARRAYdate_PCLHR(:,1)>DatiRaw(RawDate1(end)+1,1));
    end
else
    RawDate1 = [];
    RawDate2 = 1;
end
if isempty(RawDate1) == 0 && isempty(RawDate2) == 0
    Dati = [DatiRaw(1:RawDate1(end),:); ARRAYdate_PCLHR(RawDate2(1):end) TempDef_PCLHR(:,RawDate2(1):end)'];
elseif isempty(RawDate1) == 1 && isempty(RawDate2) == 0
    Dati = [ARRAYdate_PCLHR TempDef_PCLHR'];
else
    Dati = DatiRaw;
end
% Elimino appoggio più vecchio di un mese
RawDate3 = find(Dati(:,1)<now-30);
if isempty(RawDate3) == 0
    [rDati,~] = size(Dati);
    if RawDate3(end) == rDati
    else
        Dati = Dati(RawDate3(end)+1:end,:);
    end
end
if isfile(FileTemperature) == 1
    delete(FileTemperature);
end
Dati(:,1) = Dati(:,1) - 730000;
csvwrite(FileTemperature,Dati);

TempDef_PCLHR = TempDef_PCLHR';

fprintf(fileID,fmt,text);

%% Filtro
[dY_PCLHR,dZ_PCLHR,text] = filtro_PCLHR(dY_PCLHR,dZ_PCLHR,Ndevst_HR,Wdevst_HR);
fprintf(fileID,fmt,text);
if NuovoZeroPCLHR == 1 && Ndevst_HR ~= 0
    if NdatiMedia > Ndatidespike
        NdatiF = NdatiMedia;
    else
        NdatiF = Ndatidespike;
    end
    ini = round(NdatiF/2)+1;
    if rem(NdatiF,2) == 0
        ini = ini+1;
    end
    clear NDatiF
    iniST = round(Wdevst_HR/2);
    if rem(Wdevst_HR,2) == 0
        iniST = iniST+1;
    end
    iniST = iniST + margine;
    if iniST > ini
        ini = iniST;
    end
    if ini < 6
        ini = 6;
    end
    dY_PCLHR = dY_PCLHR(:,ini:end);
    dZ_PCLHR = dZ_PCLHR(:,ini:end);
    TempDef_PCLHR = TempDef_PCLHR(ini:end,:);
    DatiElabPreConvLinkHR = DatiElabPreConvLinkHR(ini:end,:);
    ARRAYdate_PCLHR = ARRAYdate_PCLHR(ini:end,1); 
    ErrPreConvLinkHR = ErrPreConvLinkHR(ini:end,:);
end

%% Finalizzo i calcoli
[rx,cx] = size(dZ_PCLHR);
% totale del singolo nodo data per data
sommaY_PCLHR = zeros(rx,cx+1);
sommaZ_PCLHR = zeros(rx,cx+1);
% cumulata del singolo nodo data per data in posizione assoluta
% il primo valore è quello di posizione assoluta iniziale
Y_PCLHR = zeros(rx,cx+1);
Z_PCLHR = zeros(rx,cx+1);
% cumulata del singolo nodo data per data in posizione relativa
% il primo valore è quello di posizione assoluta iniziale
Ylocal_PCLHR = zeros(Nnodi,Ndati);
Zlocal_PCLHR = zeros(Nnodi,Ndati);
speed_PCLHR = zeros(Nnodi,Ndati);
speed_local_PCLHR = zeros(Nnodi,Ndati);
acceleration_PCLHR = zeros(Nnodi,Ndati);
acceleration_local_PCLHR = zeros(Nnodi,Ndati);
    
if NuovoZeroPCLHR == 1
    [rE,cE] = size(DatiElabPreConvLinkHR);
    cont = 3;
    contINV = 10;
    n = 1;
    while cont<=cE
        if elab_option == 1
            sommaY_PCLHR(n,1) = cell2mat(DatiElabPreConvLinkHR(1,cont))';
            Ylocal_PCLHR(n,1) = sommaY_PCLHR(n,1);
            sommaZ_PCLHR(n,1) = cell2mat(DatiElabPreConvLinkHR(1,cont+1))';
            Zlocal_PCLHR(n,1) = sommaZ_PCLHR(n,1);
            Y_PCLHR(n,1) = cell2mat(DatiElabPreConvLinkHR(1,cont+2))';
            Z_PCLHR(n,1) = cell2mat(DatiElabPreConvLinkHR(1,cont+3))';
            speed_local_PCLHR(n,1:rE) = cell2mat(DatiElabPreConvLinkHR(:,cont+7))';
            speed_PCLHR(n,1:rE) = cell2mat(DatiElabPreConvLinkHR(:,cont+8))';
            acceleration_local_PCLHR(n,1:rE) = cell2mat(DatiElabPreConvLinkHR(:,cont+9))';
            acceleration_PCLHR(n,1:rE) = cell2mat(DatiElabPreConvLinkHR(:,cont+10))';
            cont = cont+13;
        elseif elab_option == -1
            sommaY_PCLHR(end-n+1,1) = cell2mat(DatiElabPreConvLinkHR(1,cE-contINV))';
            Ylocal_PCLHR(end-n+1,1) = sommaY_PCLHR(end-n+1,1);
            sommaZ_PCLHR(end-n+1,1) = cell2mat(DatiElabPreConvLinkHR(1,cE-contINV+1))';
            Zlocal_PCLHR(end-n+1,1) = sommaZ_PCLHR(end-n+1,1);
            Y_PCLHR(end-n+1,1) = cell2mat(DatiElabPreConvLinkHR(1,cE-contINV+2))';
            Z_PCLHR(end-n+1,1) = cell2mat(DatiElabPreConvLinkHR(1,cE-contINV+3))';
            speed_local_PCLHR(end-n+1,1:rE) = cell2mat(DatiElabPreConvLinkHR(:,cE-contINV+7))';
            speed_PCLHR(end-n+1,1:rE) = cell2mat(DatiElabPreConvLinkHR(:,cE-contINV+8))';
            acceleration_local_PCLHR(end-n+1,1:rE) = cell2mat(DatiElabPreConvLinkHR(:,cE-contINV+9))';
            acceleration_PCLHR(end-n+1,1:rE) = cell2mat(DatiElabPreConvLinkHR(:,cE-contINV+10))';
            contINV = contINV+13;
        end
        n = n+1;
    end
else
    % Primo dato
    Y_PCLHR(:,1) = Yrif(:,1);
    Z_PCLHR(:,1) = Zrif(:,1);
end
for iii = 1:cx % date
    % somma singoli spostamenti del singolo nodo
    sommaY_PCLHR(:,iii+1) = sum(dY_PCLHR(:,1:iii),2)+sommaY_PCLHR(:,1);
    sommaZ_PCLHR(:,iii+1) = sum(dZ_PCLHR(:,1:iii),2)+sommaZ_PCLHR(:,1);
    % spostamenti locali riferiti allo 0
    Ylocal_PCLHR(:,iii+1) = sommaY_PCLHR(:,iii+1);
    Zlocal_PCLHR(:,iii+1) = sommaZ_PCLHR(:,iii+1);
    % cumulata spostamenti
    if elab_option == 1
        Y_PCLHR(:,iii+1) = Y_PCLHR(:,1) + cumsum(sommaY_PCLHR(:,iii+1)) - cumsum(sommaY_PCLHR(:,1));
        Z_PCLHR(:,iii+1) = Z_PCLHR(:,1) + cumsum(sommaZ_PCLHR(:,iii+1)) - cumsum(sommaZ_PCLHR(:,1));
    elseif elab_option == -1
        Y_PCLHR = flipud(Y_PCLHR);
        Z_PCLHR = flipud(Z_PCLHR);
        Y_PCLHR(:,iii+1) = Y_PCLHR(:,1) + cumsum(flipud(sommaY_PCLHR(:,iii+1))) - cumsum(flipud(sommaY_PCLHR(:,1)));
        Z_PCLHR(:,iii+1) = Z_PCLHR(:,1) + cumsum(flipud(sommaZ_PCLHR(:,iii+1))) - cumsum(flipud(sommaZ_PCLHR(:,1)));
        Y_PCLHR = flipud(Y_PCLHR);
        Z_PCLHR = flipud(Z_PCLHR);
    end
end

%% Calcolo velocità di spostamento giornaliera
[numDate,~] = size(ARRAYdate_PCLHR); % numero di date
d = 1;
p = 1;
diffDate = 0;
n = 1;
period = 1; % calcolo giornaliero
ContSUP = [];
for dd = 1:numDate
    while diffDate < period
          d = d+1;  
          if d > numDate % Se d supera le date disponibili, esco dal ciclo while
              break
          end
          diffDate = ARRAYdate_PCLHR(d) - ARRAYdate_PCLHR(p);
    end
    if d >numDate
        break
    end
    ContSUP(n,1) = d; %#ok<*AGROW> % Creo matrice indici dell'estremo superiore della differenza
    ContINF(n,1) = p; % Creo matrice indici dell'estremo inferiore della differenza
    p = p+1; % passo alla data di partenza successiva 
    d = p; % resetto il conto di d
    n = n+1;
    diffDate = 0;
end

check = isempty(ContSUP);
if check == 0
    [nDate,~] = size(ContSUP);
    for s = 1:rPCLHR
        N = 1;
        for dd = 1:nDate
            speed_PCLHR(s,ContSUP(N,1)) = (Z_PCLHR(s,ContSUP(N,1))-Z_PCLHR(s,ContINF(N,1)))/(ARRAYdate_PCLHR(ContSUP(N,1))-ARRAYdate_PCLHR(ContINF(N,1)));
            speed_local_PCLHR(s,ContSUP(N,1)) = (Zlocal_PCLHR(s,ContSUP(N,1))-Zlocal_PCLHR(s,ContINF(N,1)))/(ARRAYdate_PCLHR(ContSUP(N,1))-ARRAYdate_PCLHR(ContINF(N,1)));
            acceleration_PCLHR(s,ContSUP(N,1)) = (speed_PCLHR(s,ContSUP(N,1))-speed_PCLHR(s,ContINF(N,1)))/(ARRAYdate_PCLHR(ContSUP(N,1))-ARRAYdate_PCLHR(ContINF(N,1)));
            acceleration_local_PCLHR(s,ContSUP(N,1)) = (speed_local_PCLHR(s,ContSUP(N,1))-speed_local_PCLHR(s,ContINF(N,1)))/(ARRAYdate_PCLHR(ContSUP(N,1))-ARRAYdate_PCLHR(ContINF(N,1)));
            N = N+1;
        end
    end
end
    
fclose(fileID);
% Approssimo i dati con il corretto numero di cifre decimali
[Y_PCLHR,Z_PCLHR,Ylocal_PCLHR,Zlocal_PCLHR,TempDef_PCLHR,speed_PCLHR,...
    speed_local_PCLHR,acceleration_PCLHR,acceleration_local_PCLHR,AlfaX_PCLHR,AlfaY_PCLHR] = ...
    approx_PCL(Y_PCLHR,Z_PCLHR,Ylocal_PCLHR,Zlocal_PCLHR,TempDef_PCLHR,speed_PCLHR,speed_local_PCLHR,...
    acceleration_PCLHR,acceleration_local_PCLHR,AlfaX_PCLHR,AlfaY_PCLHR,FileName);

% Riordino matrice errori
[r,~] = size(ErrPreConvLinkHR);
Matrice_err = zeros(r,rPCLHR);
for i = 1:r % date
    d = 1;
    for n = 1:rPCLHR % nodi
        j = 1;
        err = ErrPreConvLinkHR(i,d:d+2);
        while j <= 3
            if err(1,j) == 1
                Matrice_err(i,n) = 1;
            end
            j = j+1;
        end
        d = d+3;
    end
end
ErrPreConvLinkHR = Matrice_err';
    
text = 'PreConv Link HR calculation executed correctly';
fileID = fopen(FileName,'a');
fmt = '%s \r';
fprintf(fileID,fmt,text);
fclose(fileID);

end